#ifndef POLYMORPHIC_IMPLEMENTATION_HPP
#define POLYMORPHIC_IMPLEMENTATION_HPP

// MS compatible compilers support #pragma once
#if defined(_MSC_VER) && (_MSC_VER >= 1020)
# pragma once
#endif

#include <boost/serialization/access.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/base_object.hpp>
#include <boost/serialization/type_info_implementation.hpp>
#include <boost/serialization/extended_type_info_typeid.hpp>

#include "polymorphic_base.hpp"

class polymorphic_derived2 : public polymorphic_base
{
    friend class boost::serialization::access;

    void serialize(boost::archive::polymorphic_iarchive & ar, const unsigned int file_version);
    void serialize(boost::archive::polymorphic_oarchive & ar, const unsigned int file_version);

    virtual const char * get_key() const { 
        return "polymorphic_derived2";
    }
public:
    virtual ~polymorphic_derived2(){}
};

BOOST_CLASS_EXPORT_KEY(polymorphic_derived2)

BOOST_CLASS_TYPE_INFO(
    polymorphic_derived2,
    boost::serialization::extended_type_info_typeid<polymorphic_derived2>
)

#undef DLL_DECL

#endif // POLYMORPHIC_IMPLEMENTATION_HPP

